<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 
use Joomla\CMS\Factory;
use Joomla\CMS\MVC\Controller\BaseController;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Pagination\Pagination;


class DatafeedsControllerDataitems extends BaseController
{
    public function __construct($config = [])
    {
        parent::__construct($config);
    }
    public function display($cachable = false, $urlparams = false)
    {
        $app = Factory::getApplication();
        $db =Factory::getContainer()->get('DatabaseDriver');

        $context     = 'com_datafeed.items.';
          $lists=[];
          $formData=$app->input->getArray(['filter'=>'','list'=>'']);

          $filter=$formData['filter']??[];

          foreach (['f0','search','feed'] as $field) {
            if ( isset($filter[$field])) {
              $app->setUserState($context.$field,$filter[$field]);
            } else {
              $filter[$field]=$app->getUserState($context.$field,  '', 'string');

            }
          }
          $list=$formData['list'];

          if ( isset($list['limit'])) {
            $app->setUserState($context.'limit',$list['limit']);
          } else {
             $list['limit']=$app->getUserState($context.'limit',  $app->get('list_limit'), 'int');
          }

          if ( isset($list['fullordering'])) {
            $app->setUserState($context.'fullordering',$list['fullordering']);
          } else {
             $list['fullordering']=$app->getUserState($context.'fullordering',  'feed DESC', 'string');
          }

          if ( isset($list['showimage'])) {
            $app->setUserState($context.'showimage',$list['showimage']);
          } else {
             $list['showimage']=$app->getUserState($context.'showimage',  '', 'string');
          }

          $lists['filter']=$filter;
          $lists['list']=$list;
          extract($filter);
          extract($list);
          $limitstart      = $app->getUserStateFromRequest($context.'limitstart', 'limitstart', 0, 'int');
        $where = [];
        if ($f0) {
            $where[] = "i.field0 = ".$db->Quote($f0);
          }
        if ($feed) {
            $where[] = "i.feed = ".$db->Quote($feed);
          }
        if ($search) {
            $where[] = 'i.title LIKE '.$db->Quote('%'.$search.'%');
        }

        $where      = count($where) ?' WHERE '.implode(' AND ', $where) : '';
        $order_by   = ' ORDER BY '.$fullordering;
        $query = 'SELECT COUNT(*)' .' FROM #__dataitems AS i' .$where ;

        $db->setQuery($query);

        $total = $db->loadResult();
        $pageNav = new Pagination($total, $limitstart, $limit);
        $query = "SELECT `field0`,`price`,`title`,`hits`,`items_id`,`image`,`feed`,`url` FROM #__dataitems as i $where $order_by LIMIT {$pageNav->limitstart},{$pageNav->limit}";
        $db->setQuery($query);

        $rows = $db->loadObjectList();
        require_once(JPATH_COMPONENT.'/views/dataitems.php');
        DatafeedsViewDataitems::display($rows, $pageNav, $lists);
    }

    public function resethits()
    {
        $input = Factory::getApplication()->input;
        $db =Factory::getContainer()->get('DatabaseDriver');
        $id     = $input->get('id', 0, 'int');
        $query = "UPDATE #__dataitems SET hits = 0 WHERE items_id =" . $id;
        $db->setQuery($query);
        $db->execute();
        $this->setRedirect('index.php?option=com_datafeeds&c=dataitems', Text::_('Hits Reset'));
    }
}
