<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 
$fields = ['field1', 'field2', 'field3', 'field4', 'field5', 'field6', 'field7', 'field8', 'field9', 'field10', 'field11', 'field12', 'field13', 'field14', 'field15', 'field16', 'field17', 'field18', 'field19', 'title', 'url', 'image', 'price'];
if (php_sapi_name() != 'cli') {
    header("Content-Type: text/plain");
    header("Cache-Control: no-cache, must-revalidate");
    header("Pragma: no-cache");
    header("Expires: Sat, 26 Jul 1997 05:00:00 GMT");
}

$in_joomla = defined('_JEXEC');

if (!defined('_JEXEC')) {
    define('_JEXEC', 1);
}

\defined('_JEXEC') or die('Restricted access'); //For JED Checker
require_once dirname(__FILE__) . '/../../../../configuration.php';
$config = new  JConfig();
$db_host = $config->host;
$db_user = $config->user;
$db_password = $config->password;
$db_database = $config->db;
$fromname = $config->fromname;
$mailsite = $config->mailfrom;
$mailfrom = "$fromname <$mailsite>";
$db_table = $config->dbprefix . 'dataitems';
$tmp_table = $config->dbprefix . 'tmpdataitems';
$db_feeds = $config->dbprefix . 'datafeeds';

require_once "generic_cb.php";
include_once "mysqli.php";
db_connect($db_host, $db_user, $db_password, $db_database);
if (!function_exists('storeitem')) {
    include_once "feedsql.php";
}
require_once "xml_fetch.php";


$http_host = $_SERVER['HTTP_HOST'] ?? 'CLI';
$r_feed = $_REQUEST['feed']??'';
$r_freq = (int)($_REQUEST['freq']??0);
if ($r_feed == 'Clean Up') {
    clean_up();
    exit;
}
if ($r_feed) {
    $where[] = '`feed` = ' . db_real_escape_string($r_feed, true);
}
if ($r_freq) {
    $where[] = "(`last_update` + interval $r_freq second< now())";
} else {
    $where[] = "(`last_update` + interval `freq` second< now())";
}
$where[] = 'published>0';

$where_q = "WHERE " . join(" AND ", $where);
sql_count();
$feed_q = "SELECT SQL_CALC_FOUND_ROWS * from $db_feeds $where_q order by rand() DESC ";
$_feeds = db_query($feed_q);
$feed_c = "SELECT FOUND_ROWS() as c";
$_c = db_fetch_assoc(db_query($feed_c));
$c = $_c['c'];
echo "Number of feeds in this update : $c\n";
while ($feed_opts = db_fetch_assoc($_feeds)) {
    flush();
    set_time_limit(ini_get('max_execution_time'));
    $name = $feed_opts['feed'];
    $feed_opts['feed'] = preg_replace("#:.*#", "", $name);
    $feed_id = $feed_opts['feed_id'];
    $update = $feed_opts['last_update'];
    df_check_load();
    StopWatch(__LINE__ . " : START  $name previous $update");
    pre_clean_up($feed_id);
    $db_table = $tmp_table;

    $c--;
    $feed_url  = str_replace("&amp;", "&", $feed_opts['feed_url']);
    $class = $feed_opts['class'];

    $callback = $feed_opts['callback'];
    if (!function_exists($callback)) {
        mail($mailfrom, "Datafeeds report: callback error", "Callback function $feed_callback does not exist ( used for feed $name )", "From: " . $mailfrom);
        $callback = 'generic_cb';
    }
    $rss = bare_fetch(
        $feed_url,
        $class,
        $callback
    );

    $status = is_bool($rss) ? $rss : $rss->status;


    if ($status) {
        if ($msg = $rss->getnotice()) {
            print $msg;
        }
	 if (function_exists('lastitems')) {
                             lastitems();
                             StopWatch(__LINE__. " : FETCH END  $name ***");
        }

	#if present this function will run after al items are loaded into the database ( $db_table - tmp table )
	#this allows to change items in bulk using mysql queries
        if (function_exists('feedcron_on_success')) {
            feedcron_on_success($feed_id);
        }
        $db_table = $config->dbprefix . 'dataitems';
        feed_clean_up($feed_id);
        $_cursor = db_query("update $db_feeds set `last_update`=now(),`published`=1 where feed_id='$feed_id' and `published` > 0");
        StopWatch(__LINE__ . " : END  $name (" . $rss->count . ") ***");
        if (!$in_joomla) {
            $fail = '';
            if (!defined('DISABLE_RAW_CHECK')) {
                // simple check on missing fields
                $current = &$rss->example_raw;
                $stored = json_decode($feed_opts['example_raw'], true);
                $old = [];
                $new = array_keys($current);
                if (is_array($stored)) {
                    $old = array_keys($stored);
                    // kan arraydiff ook twee kanten op
                    $d = array_diff($old, $new);
                    $e = array_diff($new, $old);

                    if (count($d) || count($e)) {
                        $fail .= "\nRaw data keys differ\n";
                        $fail .= "====== raw data keys differ ======\n";
                        ob_start();
                        print_r($d);
                        print_r($e);
                        $fail = ob_get_clean();
                    }
                }
            }  // ! defined
            if (!defined('DISABLE_KEY_CHECK')) {
                $current = &$rss->example_raw;
                foreach ($fields as $v) {
                    if (
                        !empty($feed_opts[$v])
                        && !isset($current[$feed_opts[$v]])
                    ) {
                        $fail .= "\nkey not existing: $v " . $feed_opts[$v];
                    }
                }
            }
            if ($fail) {
                $sql_fail = db_real_escape_string(json_encode([["<h3>fetch report</h3>" => "<pre>$fail</pre>"]]), true);
                $_cursor = db_query("update $db_feeds set `published`=2,example=$sql_fail where feed='$name'");
                // send the mail only once
                if (isset($feed_opts['published']) && $feed_opts['published'] != 2) {
                    mail($mailfrom, "Datafeeds report: configuration warning", "$name\n$fail\n" . $http_host, "From: " . $mailfrom);
                }
            }
        }
    } else {
        if ($msg = $rss->geterror()) {
            print $msg;
        }
        StopWatch(__LINE__ . " : ERROR no Items ? :  $name");
        $_cursor = db_query("update $db_feeds set `published`=2 where feed='$name'");
        $db_table = $config->dbprefix . 'dataitems';
        if (!$in_joomla) {
            if (!defined('DISABLE_ITEMS_CHECK')) {
                // send the mail only once
                if (isset($feed_opts['published']) && $feed_opts['published'] != 2) {
                    mail($mailfrom, "Datafeeds report: data parsing error", "Feed is empty  : $name?\n" . $http_host, "From: " . $mailfrom);
                }
            }
        }
    }
}

print "\n";
if ($r_feed) {
    if (isset($rss->example_raw)) {
        print_r($rss->example_raw);
    }
    if (isset($rss->examples)) {
        print_r($rss->examples);
    }
}
if (!$r_feed) {
    clean_up();
    if (function_exists('feedcron_on_finish')) {
        feedcron_on_finish();
    }
}
sql_count();


function StopWatch($x)
{
    static $wstart = false, $wprev = 0;
    list($usec, $sec) = explode(' ', microtime());
    $wtime = ($sec + $usec);
    if ($wstart === false) {
        $wstart = $wtime;
        $wprev = $wtime;
    }
    $p = round($wtime - $wstart,1);
    $q = round($wtime - $wprev,2);
    $wprev = $wtime;
    printf("$x :  %2.3f delta: %2.3f" . "\n", $p, $q);

    return $p;
}



function df_check_load($exit = true)
{
    if (!function_exists('sys_getloadavg')) {
        return;
    }
    $load = sys_getloadavg();
    if (!is_array($load)) {
        return;
    }
    echo date(DATE_ATOM) . "\n" . 'System load:' . implode(",", $load) . "\n";
    if (DF_LOAD_CHECK !== true) {
        return;
    }
    while ($load[0] > DF_LOAD_MAX) {
        if (php_sapi_name() == 'cli') {
		$load0=round($load[0],1);
            echo "System load: {$load0} Sleeping\n";
            sleep(DF_LOAD_WAIT);
            $load = sys_getloadavg();
        } else {
            if ($exit) {
		$load0=round($load[0],1);
                header('HTTP/1.1 503 Too busy, try again later');
                die('Server too busy(Load: ' . $load0 . ' Max: ' . DF_LOAD_MAX . '). Please try again later. <a href="http://affiliatefeeds.nl/en/217-load-protection.html">help</a>');
            } else {
                return false;
            }
        }
    }
    return true;
}
