<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 


global $df_mysqli;
function db_connect($db_host, $db_user, $db_password, $db_database)
{
    global $df_mysqli;
    $db_port =   ini_get("mysqli.default_port");
    $db_socket =   ini_get("mysqli.default_socket");
    # from joomla
    if (preg_match('/^(?P<host>((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?))(:(?P<port>.+))?$/', $db_host, $matches)) {
        $db_host = $matches['host'];
        if (!empty($matches['port'])) {
            $db_port = $matches['port'];
        }
    } elseif (preg_match('/^(?P<host>\[.*\])(:(?P<port>.+))?$/', $db_host, $matches)) {
        $db_host = $matches['host'];
        if (!empty($matches['port'])) {
            $db_port = $matches['port'];
        }
    } elseif (preg_match('/^(?P<host>(\w+:\/{2,3})?[a-z0-9\.\-]+)(:(?P<port>[^:]+))?$/i', $db_host, $matches)) {
        $db_host = $matches['host'];
        if (!empty($matches['port'])) {
            $db_port = $matches['port'];
        }
    } elseif (preg_match('/^:(?P<port>[^:]+)$/', $db_host, $matches)) {
        $db_host = 'localhost';
        $db_port = $matches['port'];
    }
    if (is_numeric($db_port)) {
        $db_port = (int) $db_port;
    } else {
        $db_socket = $db_port;
    }

    if (! ($df_mysqli=new mysqli($db_host, $db_user, $db_password, null, $db_port, $db_socket))) {
        $_errorMsg = 'Could not connect to MySQLi';
        if (defined('DF_CGI')) {
            echo "</br>";
        }
        echo "\n";
        echo $_errorMsg;
        if (defined('DF_CGI')) {
            echo "</br>";
        }
        echo "\n";
        exit;
    }
    db_select_db($db_database);
    if (Utf8mb4Support($df_mysqli)) {
        db_query("set names utf8mb4");
    } else {
        db_query("set names utf8");
    }
    db_query("SET SESSION sql_mode = ''");
}

function Utf8mb4Support($mysqli)
{
        global $db_feeds;
        $query="SHOW TABLE STATUS LIKE  '$db_feeds'";
        $result=db_query($query);
        $row=$result->fetch_assoc();
        $collation=$row['Collation'];
    if (strpos($collation, 'utf8_')===0) {
        return false;
    }

    if (strpos($collation, 'utf8mb4_')===0) {
        return true;
    }
        // from joomla
                $client_version = mysqli_get_client_info();
                $server_version = mysqli_get_server_info($mysqli);

    if (version_compare($server_version, '5.5.3', '<')) {
            return false;
    } else {
        if (strpos($client_version, 'mysqlnd') !== false) {
                        $client_version = preg_replace('/^\D+([\d.]+).*/', '$1', $client_version);

                        return version_compare($client_version, '5.0.9', '>=');
        } else {
                            return version_compare($client_version, '5.5.3', '>=');
        }
    }
}


function db_select_db($db_database)
{
    global $df_mysqli;
    $df_mysqli->select_db($db_database);
}


function db_close()
{
    global $df_mysqli;
    $df_mysqli->close();
}
function db_query($query, $obsolete = false)
{
    global $df_mysqli;
    $result=false;
    try {
      $result=$df_mysqli->query($query);
    } catch (mysqli_sql_exception $e) {
	$catcherror = $e->getMessage();
	$error = $df_mysqli->error;
        error_log("Error: ". $catcherror);
        error_log("Error: ". $error);
        error_log("Query: " . $query);
        die("Mysqli Query Failed");
    }
    if ($result === true) {
        return db_affected_rows();
    } elseif ( $result === false ) {
        if (!defined('DF_CGI')) {
            echo "mysqli query failed\n";
            echo "$query\n";
            echo  $df_mysqli->error . "\n";
	} else {
        	error_log("mysqli query failed");
        	error_log($query);
        	error_log($df_mysqli->error);
	}
        die("Mysqli query failed");
    }
        return $result;
}
function db_real_escape_string($string, $quote = false)
{
    global $df_mysqli;
    if ($quote) {
        return '\''.$df_mysqli->real_escape_string($string).'\'';
    } else {
        return $df_mysqli->real_escape_string($string);
    }
}

function db_fetch_assoc($result)
{
    return $result->fetch_assoc();
}

function db_affected_rows()
{
    global $df_mysqli;
    return $df_mysqli->affected_rows;
}
