<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 
use Joomla\CMS\Layout\LayoutHelper;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Toolbar\Toolbar;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Form\Form;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Router\Route;
use Joomla\String\StringHelper;
use Joomla\CMS\Uri\Uri;


class DatafeedsViewListfeeds
{
    public static function _Toolbar()
    {
        ToolBarHelper::title(Text::_('DATAFEEDS_ADMINISTRATOR'), 'generic');
        $toolbar = Toolbar::getInstance('toolbar');
        $toolbar->publish('datafeeds.publish')->listCheck(true);
        $toolbar->unpublish('datafeeds.unpublish')->listCheck(true);
        $toolbar->delete('datafeeds.delete')->listCheck(true);
        $toolbar->standardButton('duplicate')
                                ->text('JTOOLBAR_DUPLICATE')
                                ->icon('fas fa-copy')
                                ->task('datafeed.copy')
                                ->listCheck(true);
        $toolbar->addNew('datafeed.add');

    }
    public static function display(&$rows, &$pageNav, &$lists)
    {
      HTMLHelper::_('bootstrap.tooltip');
      HTMLHelper::_('behavior.multiselect');
      HTMLHelper::stylesheet(Uri::base() .'components/com_datafeeds/assets/datafeed.css');
	Form::addFormPath(JPATH_COMPONENT . '/models/forms');
	Form::addFieldPath(JPATH_COMPONENT . '/models/fields');
	$form=new stdClass();
	$form->filterForm=Form::getInstance('com_datafeeds.filter_datafeeds', "filter_datafeeds", array('load_data' => false));
  $form->filterForm->bind($lists);
	$form->activeFilters=$lists;
  DatafeedsViewListfeeds::_Toolbar();
      ?>
<form id="adminForm" action="<?php echo Route::_('index.php?option=com_datafeeds')?>" method="post" name="adminForm" enctype="multipart/form-data" >
<div class="row">
<div class="col-md-12">
<div id="j-main-container" class="j-main-container">
<?php echo LayoutHelper::render('joomla.searchtools.default', ['view' => $form]); ?>
<div class="clearfix"></div>

        <?php
        list($order,$order_Dir)=explode(' ',$lists['list']['fullordering']??'feed DESC',2);
        echo '<table class="table table-striped" id="datafeedslist"> <thead><tr><tr><th width="5%">'.
        Text::_('ID').
        '</th><th>&nbsp;</th><th>' .
        HTMLHelper::_('searchtools.sort', 'Status', 'published', $order_Dir, $order) .
        '</th> <th class="Feed">'.
        HTMLHelper::_('searchtools.sort', 'Feed', 'feed', $order_Dir, $order).
        '</th> <th>'.
        HTMLHelper::_('searchtools.sort', 'Field 0', 'field0', $order_Dir, $order).
        '</th> <th colspan="3">'.
        HTMLHelper::_('searchtools.sort', 'Update', 'last_update', $order_Dir, $order).
        '</th> </tr> </thead><tbody> ';
        $k=0;
         foreach ($rows as $i => $row) {
            $row->checked_out=false;
            if (preg_match("#(https?|ftp)://(.*?)([^\.]+)\.[^\.]+/#", $row->feed_url, $m)) {
                $aff=StringHelper::strtolower($m[3]);
            } else {
                $aff='';
            }

            $link       = 'index.php?option=com_datafeeds&c=datafeed&task=edit&cid='. $row->id;
            $cron       = 'index.php?option=com_datafeeds&c=cron&nid='. $row->feed;
            echo "<tr class='row".( $i % 2)."'>";
            echo '<td align="center">'. $row->id. "</td>";
            echo '<td align="center">' . HTMLHelper::_('grid.id', $i,$row->id) . '</td>';
            echo '<td align="center">';
            echo HTMLHelper::_('jgrid.published', $row->published, $i, '', true, 'cb');
            echo '</td>';
            echo '<td align="left" ><a  class="'.$aff.' df_icon" title="'.$aff.'" href="'. Route::_($link). '">'.  $row->feed .'</a></td>';
            echo '<td align="left"  >'. $row->field0 . '</td>';
            if ($row->published) {
                $old=$row->old;
                echo '<td align="left"  title="last import">'.  $row->last_update .'';

                if ($old < 0) {
                    $old_text='<a href="'. Route::_($cron). '">'. Text::_('NEXT_IMPORT').'</a>';
                    echo '<td align="left"  title="run import" colspan="2">'.  $old_text .'</a>';
                } else {
                    $min=60;
                    $hour=60*$min;
                    ;
                    $day=24*$hour;
                    $week=7*$day;
                    $old_text='';
                    if ($old > 2*$week) {
                        $w=floor($old/$week);
                        $old_text='> ' . $w . ' ' . Text::_("WEEKS"). ' ';
                    } elseif ($old > 2*$day) {
                        $w=floor($old/$day);
                        $old_text='> ' . $w . ' ' . Text::_("DAYS"). ' ';
                    } elseif ($old > $hour) {
                        $w=floor($old/$hour);
                        $old_text='> ' . $w . ' ' . Text::_("HOURS"). ' ';
                    } elseif ($old > $min) {
                        $w=floor($old/$min);
                        $old_text='> ' . $w . ' ' . Text::_("MINS"). ' ';
                    } else {
                        $w=$old;
                        $old_text=  $w . ' ' . Text::_("SECS"). ' ';
                    }
                    echo '<td align="left"  title="next import">'.  $old_text .'</a>';
                    echo '<td title="force import"><a href="'. Route::_("$cron&freq=1"). '">'.  Text::_("NOW") .'</a>';
                }
            } else {
                echo '<td align="left" colspan="3">&nbsp;';
            }
            echo '</tr> ';
            $k = 1 -$k;
        }
        echo '</tbody></table>'.$pageNav->getListFooter(). '
        <input type="hidden" name="c" value="datafeeds" >
  <input id="list_fullordering" type="hidden"  name="list[fullordering]" value="'."$order $order_Dir".'"/> 
<input type="hidden" name="option" value="com_datafeeds" >
	<input type="hidden" name="boxchecked" value="0">
			<input type="hidden" name="task" value="" >';


        HTMLHelper::_('form.token') .' </div></div></div></div></form>';

    }
}
