<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 
use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Form\Form;

\define('DF_FORM_SOURCE', '<?xml version="1.0" encoding="utf-8"?>
<form>
        <fieldset>
                <field
                        name="filecontent"
                        type="editor"
                        label="COM_TEMPLATES_FIELD_SOURCE_LABEL"
                        description="COM_TEMPLATES_FIELD_SOURCE_DESC"
                        editor="codemirror|none"
                        buttons="no"
                        height="500px"
                        rows="20"
                        cols="80"
                        syntax="php"
                        filter="raw"
                />
        </fieldset>
</form>
');


class DatafeedssViewedit //extends JViewLegacy
{
    public static function display(&$content, $option, &$client)
    {
        JToolBarHelper::title(Text::_('Feeds Editor'), 'feedseditor');
        $user= Factory::getUser();
        $groups = JAccess::getGroupsByUser($user->id, false);
        if (in_array(8, $groups)) {
            JToolBarHelper::custom('edit', 'edit', 'JTOOLBAR_EDIT', 'Edit', false, false);
        } ?>
<div class="row">

<div id="j-main-container" class="span10 col-md-10">
<form id="adminForm" action="index.php" method="post" name="adminForm">
<table class="adminform">
                <tr>
                        <td>
                                <pre><?php highlight_string($content); ?></pre>
                        </td>
                </tr>
                </table>
<div class="clr"></div>
                <input type="hidden" name="option" value="com_datafeeds" />
                <input type="hidden" name="c" value="edit" />
                <input type="hidden" name="task" value="" />
                <input type="hidden" name="client" value="<?php echo $client->id; ?>" />
                <?php echo HTMLHelper::_('form.token'); ?>
                </form>
                </div>
                </div>

        <?php
    }

    public static function cancel(&$content, $option, &$client)
    {
        DatafeedssViewedit::display($content, $option, $client) ;
    }
    public static function edit(&$content, $option, &$client)
    {
        JToolBarHelper::title(Text::_('Feeds Editor'), 'feedseditor');
        JToolBarHelper::save('save');
        JToolBarHelper::apply('apply');
        JToolBarHelper::cancel('display');
        $form = Form::getInstance("source", DF_FORM_SOURCE, array("control" => "jform"));
        $form->setValue('filecontent', '', $content);
        ?>
<div class="row">
        
        <div id="j-main-container" class="span10 col-md-10">
        feeds.php - If the edit function fails use a ftp client to fetch the file and edit it directly.
                <form action="index.php" method="post" id="adminForm" name="adminForm">
                <table class="adminform">
                <tr> <th>
                               <?php echo 'feeds.php'; ?>
                        </th> </tr>
                <tr> <td>
<div class="editor-border">
                                       <?php echo $form->getInput('filecontent'); ?>
                                </div>
                        </td> </tr>
                </table>
                <div class="clr"></div>
                <input type="hidden" name="option" value="com_datafeeds" />
                <input type="hidden" name="task" value="" />
                <input type="hidden" name="c" value="edit" />
                <input type="hidden" name="client" value="<?php echo $client->id; ?>" />
               <?php echo HTMLHelper::_('form.token'); ?>
                </form>
                </div>
                </div>
               <?php
    }
}
