<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 
use Joomla\CMS\Layout\LayoutHelper;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Toolbar\Toolbar;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Form\Form;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Router\Route;


class DatafeedssViewoverview
{
    public static function feeds(&$rows, &$pageNav, &$lists)
    {

          HTMLHelper::_('bootstrap.tooltip');
                  ToolBarHelper::title(Text::_('COM_DATAFEEDS_ITEMS_SUMMARY'), 'generic');
                	Form::addFormPath(JPATH_COMPONENT . '/models/forms');
                	Form::addFieldPath(JPATH_COMPONENT . '/models/fields');
                	$form=new stdClass();
                	$form->filterForm=Form::getInstance('com_datafeeds.filter_overview', "filter_overview", array('load_data' => false));
                  $form->filterForm->bind($lists);
                	$form->activeFilters=$lists;
        ?>
<div class="row">
<form id="adminForm" action="<?php echo Route::_('index.php?option=com_datafeeds')?>" method="post" name="adminForm" enctype="multipart/form-data" >
<div class="row">
<div class="col-md-12">
<div id="j-main-container" class="j-main-container">
<?php echo LayoutHelper::render('joomla.searchtools.default', ['view' => $form]); ?>
<div class="clearfix"></div>

        <table class="table table-striped">
<tr>
<td colspan=8>
        <?php

        echo $pageNav->getListFooter();
        echo '</td><tr>
        <th>Feed</th>
        <th>Field 0</th>
        <th>Items</th>
        <th>Hits</th>
        <th title="distinct values field 1">F1</th>
        <th title="distinct values field 2">F2</th>
        <th title="distinct values field 3">F3</th>
        <th>Last item added</th>
        </tr> ';
        foreach ($rows as $row) {
            echo "<tr>
	    <td>{$row->feed}</td>
	    <td>{$row->s0}</td>
	    <td>{$row->count}</td>
	    <td>{$row->hits}</td>
	    <td>{$row->s1}</td>
	    <td>{$row->s2}</td>
	    <td>{$row->s3}</td>
	    <td>{$row->date}</td>
	    </tr>";
        }
        echo '</table></div></div>
  <input type="hidden" name="c" value="overview" >
<input type="hidden" name="option" value="com_datafeeds" >
<input type="hidden" name="boxchecked" value="0">
<input type="hidden" name="task" value="" >

        </form></div>';
    }
}
