<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 

use Joomla\CMS\Language\Text;


/*
 * This layout is a basic example of a mulitcolomn responsive layout using the flexbox css.
 * Using the flexbox css makes it very easy to deal with the different  aspect ratios of the images,resulting in different height of the container element.<br/>
 * The flexbox css is supported on al major modern browsers but it ain\'t perfect yet.

 * To create your own layout  create a template override

 * http://affiliatefeeds.nl/custom-layouts.html  More on creating a custom layout
 * http://css-tricks.com/snippets/css/a-guide-to-flexbox  All about the flexbox css
 */
echo '<div id="content">
      <div id="products">';
#use joomla language overrides to chang these
#or code them directyl in a template override

$currency=Text::_('DATAFEEDS_CURRENCY');
$more=Text::_('DATAFEEDS_READ_MORE');

if ($this->pagination) {
    $links = $this->pagination->getPagesLinks();
    echo '<div class="pagination">'.$links.'</div>';
}
echo '<ul>';
foreach ($this->dataitems as $item) {
    $title = $item['title'];
    $feed = $item['feed'];
    $alt = $title;
    $url = $item['url'];
    $price = (float)$item['price']; //decimal in database returns as string
    $image = $item['image'];
    if ($price > 0) {
        $price_formated = $currency.' '.DatafeedsModelItems::moneyFormat($price);
    } else {
        $price_formated = '&nbsp';
    }
    echo '<li>
          <a target="_blank" href="'.$url.'" rel="nofollow">
          <h2>'.$title.'</h2>
          <img loading="lazy"  class="product" src="'.$image.'" alt="'.$alt.'">
          <p class="df-price">'.$price_formated.'</p>
          <p class="df-button">'.$more.' '.$feed.'</a></p>
         </li>';
}
echo '</ul>';
if ($this->pagination) {
    echo '<div class="pagination">'.$links.'</div>';
}
echo '</div>';
?>
<style>
#products > ul:after {
    clear: both;
    content: "";
    display: block;
}
#products > ul li {
width:200px;
margin: 0 15px 15px 0;
padding: 0;
position: relative;
flex:1 0 auto;
text-align:center;
}
#products > ul img{
    margin-bottom:35px;
    max-width:200px;
}
#products > ul {
    flex-wrap:  wrap;
    justify-content:  space-around;
    display: flex;
    list-style: outside none none;
    margin: 0;
    padding: 0;
}
#products .df-price  {
    position:absolute;
    bottom:35px;
    right:-5px;
    border-radius: 2px;
    font-weight:bold;
background-color: white;
    border: 1px solid blue;
    display: block;
    font-size: 15px;
    font-weight: normal;
    height: 20px;
    line-height: 20px;
    padding: 2px;
    position: absolute;
    z-index: 5;
}
#products .df-button a {
    color: #fff;
}
#products .df-button{
background: none repeat scroll 0 0 blue;
    color: #fff;
    border-radius: 2px;
    font-style: normal;
    display:block;
margin:0px auto;
width:90%;
overflow:hidden;
    height: 22px;
    left: 10px;
    line-height: 22px;
    overflow: hidden;
    padding: 0 5px;
    text-align: center;
    text-overflow: ellipsis;
    white-space: nowrap;
    position:absolute;
    bottom:5px;

}

.pagination {
  text-align:center;
}
#products h2 {
line-height:1em;
font-size:14px;
overflow:hidden;

}

</style>
</div>

