<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 
use Joomla\CMS\Language\Text;

echo '<div id="com_datafeeds">';

if ($this->pagination) {
    $links = $this->pagination->getPagesLinks();
    echo '<div class="pagination" id="datafeeds_top">'.$links.'</div>';
}
?> 

<table class='datafeeds_list'><tbody>
<?php
$list_count = 1;
$fields=$this->get('Fields');
$currency=Text::_('DATAFEEDS_CURRENCY');
$basequery=$this->get('Basequery');

$field1 = $fields[1]??'';
$field2 = $fields[2]??'';
$field3 = $fields[3]??'';
$level=$this->where['level']??0;


foreach ($this->dataitems as $item) {
    $url = $item['url'];
    $title = $item['title'];
    $price = (float)$item['price']; //decimal in database returns as string
    $image = $item['image'];
    $s1 = $item[$field1]??'';
    $s2 = $item[$field2]??'';
    $s3 = $item[$field3]??'';
    $alt = $title;
    echo '<tr class="datafeeds_row datafeeds_row'.$list_count % 2 .'">
	<td class="datafeeds_list_img"><a class="dflink" target="_blank" href="'.$url.'" rel="nofollow"><img loading="lazy"  src="'.$image.'" alt="'.$alt.'"  /></a></td>';
    echo '<td class="datafeeds_list_title"><a class="dflink" target="_blank" href="'.$url.'" title="'.$alt.'" rel="nofollow">'.$title.'</a></td>';
    if ($price > 0) {
        echo '<td class="datafeeds_list_price"><a class="dflink" target="_blank" href="'.$url.'" rel="nofollow">'.$currency.' '.DatafeedsModelItems::moneyFormat($price).'</a></td>';
    } else {
        echo '<td class="datafeeds_list_price">&nbsp;</td>';
    }
    echo '<td>';
    if (1 != $level) {
	     $basequery['q1']=$s1;
            echo '<a href="'.DatafeedsModelItems::makeRoute($basequery).'">'.$s1.'</a>';
    }
    echo '</td><td>';
    if ($s2 && (2 != $level)) {
	     $basequery['q2']=$s2;
            echo '&nbsp;<a href="'.DatafeedsModelItems::makeRoute($basequery).'">'.$s2.'</a>';
    }
    echo '</td><td>';
    if ($s3 && (3 != $level)) {
	     $basequery['q3']=$s3;
            echo '&nbsp;<a href="'.DatafeedsModelItems::makeRoute($basequery).'">'.$s3.'</a>';
    }
    echo '</td>';
    ++$list_count;
}
echo '</tbody></table>';

if ($this->pagination) {
    echo '<div class="pagination" id="datafeeds_bottom">'.$links.'</div>';
}

echo '</div>';
?>
<style>
div.pagination{text-align:center;}
div.datafeeds{overflow:hidden;margin:0px 10px;}
div.datafeeds_description{float:right;width:75%;padding-bottom:10px;}
img.datafeeds_img{width:20%;border:0;}
.datafeeds_list_img{width:100px;height:100px;overflow:hidden;margin:1px auto;}
.datafeeds_list_price{padding-left:10px;width:100px;height:100px;overflow:hidden;}
.datafeeds_list_img img{width:100px;border:none;}
</style>

