<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

\defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Language\Text;

echo '<div id="com_datafeeds">';

$base = Uri::base(false);
#use joomla language overrides to chang these
#or code them directyl in a template override
$more = Text::_('DATAFEEDS_READ_MORE');
$currency = Text::_('DATAFEEDS_CURRENCY');
$model = $this->getModel();
if ($this->where['qt']) {
    echo $this->loadTemplate('single');
} else {

    if ($this->pagination) {
        $links = $this->pagination->getPagesLinks();
        echo '<div class="pagination" id="datafeeds_top">' . $links . '</div>';
    }
    echo '<div class="datafeeds_clear">';
    foreach ($this->dataitems as $item) {
        $product_title = $item['title'];
        $product_id = $item['items_id'];
        $alt = df_alt($product_title);
        #point to detailed information
        #$url = DatafeedsModelItems::makeRoute($this->basequery,'qt',$product_title);

        # count url
        $url  = $base . 'index.php?option=com_datafeeds&task=go&format=raw&item=' . $product_id;

        # count url bypassing joomla framewark
        #$url  = $base .'components/com_datafeeds/view.php?item='.$product_id;

        # count url  using .htaccess
        #$url  = $base .'view/'.$product_id;
        # with a rule like the one below in your .htaccess
        # RewriteRule view/([0-9]+) /components/com_datafeeds/view.php?item=$2&p=$1 [L]

        #point directly to merchant
        #$url = $item['url'];


        $price = (float)$item['price']; //decimal in database returns as string

        $product_image = $item['image'];
        echo '<div  class="df_3col_container">';
        echo '<div class="df_3col_list_title"><h2 class="df_3col_list_title"><a class="dflink" target="_blank" href="' . $url . '" rel="nofollow">' . $product_title . '</a></h2></div>';
        echo '<div class="df_3col_img" ><a class="dflink" target="_blank" href="' . $url . '" rel="nofollow"><img loading="lazy"  src="' . $product_image . '" alt="' . $alt . '"  /></a></div>';
        if ($price > 0) {
            echo '<p class="df_3col_price"><a class="dflink" target="_blank" href="' . $url . '" rel="nofollow">' .
                $currency . ' ' . $model::moneyFormat($price) .
                '</a></p>';
        } else {
            echo '<p class="df_3col_price">&nbsp;</p>';
        }

        echo '<p class="datafeeds_more"><a  class="dflink" href="' . $url . '" title="' . $product_title . '">' . $more . '</a></p>';
        echo '</div>';
    }
    echo '</div><div class="datafeeds_clear datafeeds_fix">&nbsp;</div>';
    if ($this->pagination) {
        echo '<div class="pagination" id="datafeeds_bottom">' . $links . '</div>';
    }
}
echo '</div>';
?>
<style>
    div#datafeeds_top,
    div#datafeeds_bottom {
        text-align: center;
    }

    div.datafeeds {
        overflow: hidden;
        margin: 0px 10px;
    }

    div.datafeeds_thumb {
        float: left;
        border: 1px solid;
        width: 125px;
        margin: 5px;
        height: 125px;
        overflow: hidden;
    }

    .datafeeds_thumb_img {
        width: 125px;
        margin: 1px auto;
    }

    .datafeeds_thumb_p {
        text-align: center;
        font-size: 1.1em;
        font-weight: bold;
    }

    p.datafeeds_more {
        text-align: right;
    }

    div.datafeeds_description {
        float: right;
        width: 75%;
        padding-bottom: 10px;
    }

    img.datafeeds_img {
        width: 20%;
        border: 0;
    }

    .df_3col_price {
        text-align: right;
        font-size: 1.2em;
        font-weight: bold;
    }

    div.datafeeds ul {
        list-style-position: inside;
    }

    .datafeeds_clear {
        clear: both;
    }

    .datafeeds_fix {
        display: block;
        height: 0;
        visibility: hidden;
    }

    div.df_3col_container {
        width: 30%;
        float: left;
        margin-left: 3%;
        text-align: center;
        height: 300px;
        overflow: hidden;
        margin-bottom: 5px;
    }

    div.df_3col_img {
        width: 100%;
        height: 150px;
        overflow: hidden;
        margin: 5px auto;
    }

    div.df_3col_img img {
        width: 90%;
    }

    div.df_3col_list_title {
        height: 2em;
        overflow: hidden;
    }

    h2.df_3col_list_title {
        margin: 5px 0px;
        font-size: 1.0em;
    }
</style>