<?php


/**
 * @version 23.11.dev
 * @package    Datafeeds for Joomla
 * @author     Bram <bram@brambring.nl>
 * @copyright  2023 Bram Brambring
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */

 \defined('_JEXEC') or die('Restricted access');
 

use Joomla\CMS\Factory;
use Joomla\CMS\MVC\View\HtmlView as BaseHtmlView;

class DatafeedsViewItems extends BaseHtmlView
{
    protected $dataitems = [];
    protected $pagination = null;
    protected $robots = null;
    protected $robots_depth = null;
    protected $where = null;
    protected $basequery = null;
    public function display($tpl = null)
    {
        //FUTURE: move al this to the default.php so it can be changed in a template override.
        $document = Factory::getDocument();
        $app = Factory::getApplication();
        $params = $app->getParams();

        if ($params->get('menu-meta_description')) {
            $document->setDescription($params->get('menu-meta_description'));
        }

        if ($params->get('menu-meta_keywords')) {
            $document->setMetaData('keywords', $params->get('menu-meta_keywords'));
        }
        $this->robots = $params->get('robots', 'index,follow');
        $this->dataitems = $this->get('Dataitems');
        $this->pagination = $this->get('pagination');
        $this->where = $this->get('Where');
        $this->robots_depth = $params->get('robots_depth', 9);
        $this->basequery = $this->get('Basequery');

        if (is_array($this->dataitems)) {
            parent::display($tpl);
        }
    }
}
